#include "defs.h"
#include "JElizaQt.h"

#include <boost/bind.hpp>
#include <boost/smart_ptr.hpp>



/*
 * This is part of JEliza 2.3.
 * Copyright 2006 by Tobias Schulz
 * WWW: http://jeliza.ch.to/
 *
 * JEliza is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 *
 * JEliza is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU GPL
 * along with JEliza (file gpl.txt) ; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef linux
# ifndef __APPLE__
#  include <windows.h>
# endif
#endif


#include <cstdlib>
#include <iostream>
#include <boost/bind.hpp>
#include <boost/smart_ptr.hpp>
#include "asio.hpp"

using boost::shared_ptr;


double*                     JELIZA_PROGRESS;
shared_ptr<JElizaWindow>               form;
shared_ptr<Dialog1>                    dia_options;
shared_ptr<Dialog2>                    dia_db_edit;
shared_ptr<Dialog2>                    dia_module_list_edit;
shared_ptr<Dialog3>                    dia_help;
shared_ptr<Dialog4>                    dia_changelog;
shared_ptr<Dialog5>                    dia_startup;
shared_ptr<Dialog8>                    dia_view;
shared_ptr<Dialog7>                    semanticWidgetDialog;
shared_ptr<ConnectDialog>              conn_dia;
shared_ptr<SemanticWidget>             semanticWidget;
shared_ptr<AnswerHelper>      answerHelper;
QMutex                      log_mutex;
int                         NOTHING_TO_DO = 0;
int                         ANSWER_TO_DO = 5;
string*                     global_ques;
int                         count_loop;
bool                        global_fertig = false;
bool                        startedUp = false;
string                      must_be_logged;
QProcess* kernel_process;

bool offline_mode = false;
bool www_surf_mode = true;
jeliza::string ki_name;
jeliza::string version;


auto_ptr<QString> jelizathread1_logs;
auto_ptr<QString> jelizathread1_talking;

JElizaWindow::JElizaWindow(QWidget *parent)
: QMainWindow(parent)
{
}

void jeliza::display_sentence(jeliza::string s) {
    emit answerHelper->signalAnswer(QString((s.ref() + "<br><a name=\"anch\" id=\"anch\">&nbsp;</a>").c_str()));
    emit answerHelper->signalTalkingScrollEnd(QString("anch"));

    jeliza::update_prozent(0);
}

void JElizaWindow::hideStartupDialog() {
    dia_startup->hide();
    form->showWindowNormal();
}

void JElizaWindow::on_pushButton_clicked() {
    QString qs = ui_form->lineEdit->displayText();
    qs = qs.replace(QString("Ã¼"), QString("ue"));
	qs = qs.replace(QString("Ã"), QString("ss"));
	qs = qs.replace(QString("Ã¤"), QString("ae"));
	qs = qs.replace(QString("ü"), QString("ue"));
	qs = qs.replace(QString("ß"), QString("ss"));
	qs = qs.replace(QString("ä"), QString("ae"));
	qs = qs.replace(QString("ö"), QString("oe"));
	qs = qs.replace(QString("Ü"), QString("Ue"));
	qs = qs.replace(QString("Ä"), QString("Ae"));
	qs = qs.replace(QString("Ö"), QString("Oe"));
	qs = qs.replace(QString("Ã¢ÂÂ"), QString("\""));
	qs = qs.replace(QString("Ã¢ÂÂ"), QString("\""));
	qs = qs.replace(QString("&lt;/br&gt;"), QString(" "));
	std::wstring ws(qs.toStdWString());
	jeliza::string ques;
	for (unsigned int x = 0; x < ws.size(); x++) {
	    unsigned long y = ws[x];
	    cout << ws[x] << " " << y << endl;
	    if (y == 228) {
	        ques += "ae";
	    }
	    else if (y == 196) {
	        ques += "Ae";
	    }
	    else if (y == 252) {
	        ques += "ue";
	    }
	    else if (y == 220) {
	        ques += "Ue";
	    }
	    else if (y == 246) {
	        ques += "oe";
	    }
	    else if (y == 214) {
	        ques += "Oe";
	    }
	    else if (y == 223) {
	        ques += "ss";
	    }

        else {
            char array[2];
            array[0] = y;
            array[1] = '\0';
	        ques += array;
	    }
	}


    ui_form->lineEdit->setText(QString());
    ques = ques.toASCII();

    if (ques.get_lower().contains("windows") && ques.get_lower().contains("gut")) {
        form->showWindowEE();
    }

    jeliza::comm_send("QUESTION:" + ques);
}

void JElizaWindow::on_lineEdit_returnPressed() {
    on_pushButton_clicked();
}

void QJElizaApplication::exitNow() {
    jeliza::comm_send("EXIT:EXIT");
    std::exit(0);
}

QJElizaApplication::QJElizaApplication(int a, char** b)
: QApplication(a, b)
{
}

void check_new_version() {
	while (!version.size()) {
		jeliza::msleep(1000);
	}
	
	jeliza::string new_online(jeliza::download("http://jeliza.sourceforge.net/developer/down/version"));
	new_online = new_online.replace("r", "");
	new_online = new_online.replace("rev", "");
	new_online = new_online.replace(".", "");
	new_online.strip();
	
	if (new_online != version) {
		emit answerHelper->signalNewVersionOnline(QString(new_online.ref().c_str()));
	}
}

void AnswerHelper::slotNewVersionOnline(QString new_online) {
    int ret = QMessageBox::warning(form.get(), tr("Update"),
            "Eine neue Version dieses Programmes ist auf der Website verfuegbar.\n"
            "Es wird dringend empfohlen, auf diese neue Version zu aktualisieren, da in der "
            "Version, die Sie jetzt benutzen, einige Fehler enthalten sind. "
            "Die Aktualisierung ist fuer die einwandfreie Funktion auf ihrem Computer notwendig.\n\n"
            "Das Update heisst: Revision " + new_online + "\n\n"
            "Sie erhalten auf der Projektwebsite unter:\n"
            "http://jeliza.sf.net/\n\n"
            "Der Download ist kostenlos.",
            QMessageBox::Yes,
            QMessageBox::Yes);
}

void make_connection() {
    conn_dia->exec();
    if (conn_dia->result() == QDialog::Rejected) {
        std::exit(0);
    }

    string ip = jeliza::string(conn_dia->from->ip->displayText().toStdString()).get_strip().ref();

    form->showWindowNormal();

    if (ip == "127.0.0.1") {
        kernel_process = new QProcess(NULL);

        kernel_process->setStandardOutputFile("jeliza.log");
        kernel_process->setStandardErrorFile("jeliza_err.log");
#ifdef linux
        kernel_process->startDetached(QString("./bin/kernel"), QStringList());
#else
# if defined(__APPLE__)
        kernel_process->startDetached(QString("./bin/kernel"), QStringList());
# else
        kernel_process->startDetached(QString(".\\kernel.exe"), QStringList());
# endif
#endif


    } else {
        emit answerHelper->everythingReady();
    }

	asio::thread t_v(check_new_version);
    asio::thread t_w(boost::bind(jeliza::comm_init_client, ip, true, true));

    jeliza::comm_send("HELLO:.");
}

int main(int argc, char* argv[]) {
    jelizathread1_logs.reset(new QString());
    jelizathread1_talking.reset(new QString());


#ifdef JELIZA_DEBUG
# ifndef __APPLE__
#  ifndef linux
    if (AllocConsole()) {
        freopen("CON", "w", stdout);
        freopen("CON", "w", stderr);
    }
#  endif
# endif
#endif

    double JELIZA_PROGRESS2 = 0.0;
    JELIZA_PROGRESS = &JELIZA_PROGRESS2;

    QJElizaApplication app(argc, argv);
    app.connect(&app, SIGNAL(aboutToQuit()),
             &app, SLOT(exitNow()));
    
    form.reset(new JElizaWindow);
    dia_options.reset(new Dialog1);
    dia_db_edit.reset(new Dialog2);
    dia_module_list_edit.reset(new Dialog2);
    dia_help.reset(new Dialog3);
    dia_changelog.reset(new Dialog4);
    dia_startup.reset(new Dialog5);
    dia_view.reset(new Dialog8);
    semanticWidgetDialog.reset(new Dialog7);
    conn_dia.reset(new ConnectDialog);
    semanticWidget.reset(new SemanticWidget);

    Ui::jelizaWindow* from_ui_form = new Ui::jelizaWindow();
    from_ui_form->setupUi(form.get());
    form->ui_form = from_ui_form;
    from_ui_form->will_show_log->setChecked(false);
    from_ui_form->textEdit_2->hide();


    Ui::ConnectDialog* from_codi = new Ui::ConnectDialog();
    from_codi->setupUi(conn_dia.get());
    conn_dia->from = from_codi;

    Ui::Dialog* from_ui_dia = new Ui::Dialog();
    from_ui_dia->setupUi(dia_options.get());
    form->ui_dia = from_ui_dia;
    dia_options->ui_dia = from_ui_dia;
    dia_options->ui_form = form->ui_form;

    Ui::db_edit* from_ui_dia2 = new Ui::db_edit();
    from_ui_dia2->setupUi(dia_db_edit.get());
    dia_db_edit->ui_dia = from_ui_dia2;
    dia_db_edit->ui_form = form->ui_form;

    Ui::db_edit* from_ui_dia2_2 = new Ui::db_edit();
    from_ui_dia2_2->setupUi(dia_module_list_edit.get());
    dia_module_list_edit->ui_dia = from_ui_dia2_2;
    dia_module_list_edit->ui_form = form->ui_form;

    Ui::HelpDialog* from_ui_dia3 = new Ui::HelpDialog();
    from_ui_dia3->setupUi(dia_help.get());
    dia_help->ui_dia = from_ui_dia3;
    dia_help->ui_form = form->ui_form;
    
    Ui::ViewDialog* from_ui_dia_view = new Ui::ViewDialog();
    from_ui_dia_view->setupUi(dia_view.get());
    dia_view->ui_dia = from_ui_dia_view;
    dia_view->ui_form = form->ui_form;

    Ui::ChangelogDialog* from_ui_dia4 = new Ui::ChangelogDialog();
    from_ui_dia4->setupUi(dia_changelog.get());
    dia_changelog->ui_dia = from_ui_dia4;
    dia_changelog->ui_form = form->ui_form;
    dia_changelog->init_changelog();

    semanticWidgetDialog.reset(new Dialog7());
    semanticWidget.reset(new SemanticWidget(semanticWidgetDialog.get()));


    answerHelper.reset(new AnswerHelper());

    answerHelper->connect(&(*answerHelper), SIGNAL(signalLog(QString)),
             form->ui_form->textEdit_2, SLOT(setHtml(QString)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalLogScrollEnd(QString)),
             form->ui_form->textEdit_2, SLOT(scrollToAnchor(QString)));

    answerHelper->connect(&(*answerHelper), SIGNAL(signalAnswer(QString)),
             form->ui_form->textEdit, SLOT(setHtml(QString)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalTalkingScrollEnd(QString)),
             form->ui_form->textEdit, SLOT(scrollToAnchor(QString)));

    answerHelper->connect(&(*answerHelper), SIGNAL(signalUpdateProgressbar(int)),
            form->ui_form->bar, SLOT(setValue(int)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalHideProgressbar()),
            form->ui_form->bar, SLOT(hide()));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalShowProgressbar()),
            form->ui_form->bar, SLOT(show()));

    form->ui_form->bar->setRange(0, 100);
    form->ui_form->bar->hide();

    answerHelper->connect(&(*answerHelper), SIGNAL(signalUpdateStatusbar(QString)),
            form->ui_form->statusbar, SLOT(showMessage(QString)));
    answerHelper->connect(form->ui_form->statusbar, SIGNAL(messageChanged(QString)),
            form.get(), SLOT(slotStatusbarUpdated(QString)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalChangeWindowTitle(QString)),
            form.get(), SLOT(setWindowTitle(QString)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalChangeHelpWindowText1(QString)),
            dia_help->ui_dia->label, SLOT(setText(QString)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalChangeHelpWindowText2(QString)),
            dia_help->ui_dia->label_2, SLOT(setText(QString)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalMsg(QString)),
            form->ui_form->msg, SLOT(setHtml(QString)));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalMsgGenus(QString)),
            form->ui_form->msg_2, SLOT(setHtml(QString)));

    answerHelper->connect(&(*answerHelper), SIGNAL(signalMsgNounOrNot(QString)),
            form->ui_form->msg_3, SLOT(setHtml(QString)));

    answerHelper->connect(&(*answerHelper), SIGNAL(signalShowMsgWindow()),
            &(*answerHelper), SLOT(showMsgWindow()));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalHideMsgWindow()),
            &(*answerHelper), SLOT(hideMsgWindow()));

    answerHelper->connect(&(*answerHelper), SIGNAL(signalShowMsgGenusWindow()),
            &(*answerHelper), SLOT(showMsgGenusWindow()));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalHideMsgGenusWindow()),
            &(*answerHelper), SLOT(hideMsgGenusWindow()));

    answerHelper->connect(&(*answerHelper), SIGNAL(signalShowMsgNounOrNotWindow()),
            &(*answerHelper), SLOT(showMsgNounOrNotWindow()));
    answerHelper->connect(&(*answerHelper), SIGNAL(signalHideMsgNounOrNotWindow()),
            &(*answerHelper), SLOT(hideMsgNounOrNotWindow()));

    answerHelper->connect(&(*answerHelper), SIGNAL(everythingReady()),
            &(*answerHelper), SLOT(slotEverythingReady()));

    answerHelper->connect(dia_view->ui_dia->weiter, SIGNAL(released()),
    		&(*answerHelper), SLOT(close_view()));
    		
    answerHelper->connect(&(*answerHelper), SIGNAL(signalNewVersionOnline(QString)),
    		&(*answerHelper), SLOT(slotNewVersionOnline(QString)));

    form->ui_form->lineEdit->setEnabled(false);
    form->ui_form->textEdit->setEnabled(false);
    form->ui_form->pushButton->setEnabled(false);
    form->ui_form->textEdit->setHtml(QString("Bitte warten Sie, bis das semantische Netz geladen wurde..."));
    
    ifstream i_check("temp/already_initialized.tmp");
    if (!i_check) {
    	ofstream o_check("temp/already_initialized.tmp");
    	o_check.close();
    	dia_view->exec();
    } else {
    	make_connection();
    }

    return app.exec();
}

void AnswerHelper::close_view() {
	dia_view->hide();
	make_connection();
}

void JElizaWindow::showWindowNormal() {
    hide();
    ui_form->normalscreen->hide();
    ui_form->menubar->show();
    ui_form->msg_box->hide();
    ui_form->msg_box_2->hide();
    ui_form->msg_box_3->hide();

    form->setWindowFlags(0);
    form->resize(700, 550);

    showNormal();
}
void JElizaWindow::showWindowFullscreen() {
    hide();

    ui_form->textEdit_2->hide();
    ui_form->menubar->hide();
    ui_form->msg_box->hide();
    ui_form->msg_box_2->hide();
    ui_form->msg_box_3->hide();

    form->setWindowFlags(Qt::FramelessWindowHint | Qt::WindowStaysOnTopHint);
    form->move(0,0);
    showMaximized();

    ui_form->normalscreen->show();
}

void JElizaWindow::showWindowEE() {
    hide();

    Dialog6* dia = new Dialog6();

    Ui::EasterEgg* from_ui_dia = new Ui::EasterEgg();
    from_ui_dia->setupUi(dia);
    dia->ui_dia = from_ui_dia;
    dia->ui_form = form->ui_form;

    dia->setWindowFlags(Qt::FramelessWindowHint | Qt::WindowStaysOnTopHint);
    dia->move(0,0);
    dia->showMaximized();
}

void JElizaWindow::on_normalscreen_clicked() {
    dia_options->close();
    form->showWindowNormal();
}
void JElizaWindow::on_fullscreen_triggered() {
    dia_options->close();
    form->showWindowFullscreen();
}

void jeliza::log(std::string str) {
    cout << str << endl << flush;

    QString s(str.c_str());
    s = s.replace("\n", "<br/>").replace(" ", "&nbsp;");

    if ((*jelizathread1_logs).size() > 10000) {
        (*jelizathread1_logs) = "";
    }

    (*jelizathread1_logs) += s + QString("<br/>");

    emit answerHelper->signalLog(*jelizathread1_logs + QString("<a name=\"line\">&nbsp;</a>"));
    emit answerHelper->signalLogScrollEnd(QString("line"));
}


int AKTUELLE_PROZENT = 0;

void jeliza::update_prozent(float fl) {
    stringstream sst;
    std::string i;
    sst << fl;
    sst >> i;

    QString send;

    if (fl == 0) {
        send = QString("JEliza hoert zu...");
    } else {
        send = QString("JEliza denkt nach...");
        // (" + QString(i.c_str()) + "%)
    }

    emit answerHelper->signalUpdateStatusbar(send);
    emit answerHelper->signalUpdateProgressbar((int)(fl));
    if (fl < 1) {
        emit answerHelper->signalHideProgressbar();
    }
    else {
        emit answerHelper->signalShowProgressbar();
    }
}

void JElizaWindow::on_actionGespr_ch_triggered() {
    form->ui_form->textEdit->setHtml(QString());
    jelizathread1_talking.reset(new QString());
    jeliza::comm_send("CLEAR:TALKING");
}
void Dialog1::on_clear_screen_clicked() {
    form->ui_form->textEdit->setHtml(QString());
    jelizathread1_talking.reset(new QString());
    jeliza::comm_send("CLEAR:TALKING");
}

void JElizaWindow::on_actionEinstellungen_triggered() {
    dia_options->show();
}

void JElizaWindow::on_actionDatenbank_triggered() {
    int ret = QMessageBox::warning(this, tr("JEliza"),
            tr("Soll die aktuelle Datenbank wirklich geloescht und eine neue angelegt werden?"),
            QMessageBox::Yes | QMessageBox::No,
            QMessageBox::No);

	if (ret == QMessageBox::Yes) {
		ofstream o(("lang_" + jeliza::get_lang_str() + "/jeliza-standard.xml").ref().c_str());
		o << "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>" << endl << endl << "<jdb>" << endl << "</jdb>" << endl;
		o.close();
		jeliza::comm_send("INIT:.");
	}
}

void Dialog1::on_db_download_clicked() {
    int ret = QMessageBox::warning(form.get(), tr("JEliza"),
            tr("Soll die aktuelle Datenbank wirklich geleert und die aktuelle Version aus dem Internet heruntergeladen werden?"),
            QMessageBox::Yes | QMessageBox::No,
            QMessageBox::No);

	if (ret == QMessageBox::Yes) {
        string all = "GET_ONLINE_DB_STRING";
        all += ":http:://jeliza.sourceforge.net/databases/jeliza-person-online-new.LANG.xml";
        if (dia_options->ui_dia->db_smalltalk->isChecked()) {
            all += ":http:://jeliza.sourceforge.net/databases/jeliza-smalltalk-online-new.LANG.xml";
        }
        if (dia_options->ui_dia->db_sprueche->isChecked()) {
            all += ":http:://jeliza.sourceforge.net/databases/jeliza-sprueche-online-new.LANG.xml";
        }


        cout << all << endl;

        connect(this, SIGNAL(signal_on_download_finished()), this, SLOT(on_download_finished()));

        jeliza::comm_send(all);
	}
}

void Dialog1::on_download_finished() {
    QMessageBox::warning(form.get(), QString("JEliza"),
            QString("Die aktuelle Version der Datenbank wurde aus dem Internet heruntergeladen."),
            QMessageBox::Ok,
            QMessageBox::Ok);
}

void Dialog1::on_import_finished() {
    QMessageBox::information(this, tr("JEliza"),
            ":Erfolgreich geladen!",
            QMessageBox::Ok,
            QMessageBox::Ok);
}

void Dialog1::on_db_edit_clicked() {
    jeliza::string all;

    ifstream i(("lang_" + jeliza::get_lang_str() + "/jeliza-standard.xml").ref().c_str());
    jeliza::string temp;
    while (i) {
        getline(i, temp.ref());
        temp.strip();

        all += temp;
        all += "\n";
    }

    dia_db_edit->ui_dia->editor->setText(QString(all.ref().c_str()));
    dia_db_edit->file = ("lang_" + jeliza::get_lang_str() + "/jeliza-standard.xml").ref().c_str();
    dia_db_edit->full_name = "Datenbankeditor";
    dia_db_edit->init_editor();
    dia_db_edit->show();
}

void JElizaWindow::on_actionWissen_importieren_triggered() {
    QString filename = QFileDialog::getOpenFileName(this, tr("Wissen Importieren"),
            "",
            tr("JEliza Datenbanken (*.xml)"));

    if (filename.size() > 0) {
		QMessageBox::information(this, tr("JEliza"),
            filename + "\nWird nun in die Datenbank geladen",
            QMessageBox::Ok,
            QMessageBox::Ok);

        ifstream i(filename.toStdString().c_str());
        string all;
        string s;
        while (i) {
            getline(i, s);
            all += s;
            all += "\n";
        }
        jeliza::comm_send("IMPORT_DB:" + jeliza::string(all).replace(string("\r"), string("")).replace(string("\n"), string("<BR>")).ref());

        connect(dia_options.get(), SIGNAL(signal_on_import_finished()), dia_options.get(), SLOT(on_import_finished()));
    }
}

void Dialog5::updateStatusBar(float fl) {
    QString send;

    stringstream sst;
    string s;
    sst << fl;
    sst >> s;

    send = QString(QString(s.c_str()) + "%");

    emit signalUpdateStatusbar(send);
}

void JElizaWindow::slotStatusbarUpdated(QString) {
    waitForStatusbar = false;
}

void JElizaWindow::on_will_show_log_toggled(bool checked) {
    if (checked) {
        ui_form->textEdit_2->show();
    } else {
        ui_form->textEdit_2->hide();
    }
}

void JElizaWindow::on_actionWissen_exportieren_triggered() {
    QString filename = QFileDialog::getSaveFileName(this, tr("Wissen Exportieren"),
            "",
            tr("JEliza Datenbanken (*.xml)"));

    if (filename.size() > 0) {
		QMessageBox::information(this, tr("JEliza"),
            "Die Datenbank wird nun nach " + filename + " exportiert.",
            QMessageBox::Ok,
            QMessageBox::Ok);

        this->connect(this, SIGNAL(signalAfterExport(QString)), this, SLOT(slotAfterExport(QString)));


        jeliza::comm_send("GET_DB_STRING:" + jeliza::string(filename.toStdString()).replace_nocase_safe(s(":"), s("")).ref());
	}
}

void JElizaWindow::slotAfterExport(QString q) {
    QMessageBox::information(form.get(), QString("JEliza"),
            q,
            QMessageBox::Ok,
            QMessageBox::Ok);
}

void exportiere_db(string file, string db) {
    ofstream o(file.c_str());
    o << db << endl;
    o.close();

    emit form->signalAfterExport(QString((file + ":\nErfolgreich exportiert!").c_str()));
}

void JElizaWindow::on_actionSemantisches_Netz_triggered() {
    semanticWidgetDialog->showMaximized();
}

void Dialog1::on_mode_www_toggled() {
    www_surf_mode = !www_surf_mode;
    jeliza::comm_send(string("WWW_SURF_MODE:") + ((www_surf_mode) ? "1" : "0"));
}
bool jeliza::use_online_db = true;
void Dialog1::on_access_online_db_toggled() {
    jeliza::use_online_db = !jeliza::use_online_db;
    if (jeliza::use_online_db) {
        jeliza::comm_send("USE_ONLINE_DB:YES");
    }
    else {
        jeliza::comm_send("USE_ONLINE_DB:NO");
    }
}
void Dialog1::on_mode_offline_toggled() {
    offline_mode = !offline_mode;
    jeliza::comm_send(string("OFFLINE_MODE:") + ((offline_mode) ? "1" : "0"));
}

void Dialog1::on_speech_toggled() {
    jeliza::speech_activated = !jeliza::speech_activated;
}

void Dialog1::on_arin_load_clicked() {
/**
 ** Noch ueber Socket implementieren!!!!!!!!
 **
 **

    ifstream i("wikipedia_words.tmp");
    wikipedia_words << NULL;
    string s;
    while (i) {
        i >> s;
        if (s.size() > 1) {
            allWikiWords += "+";
            allWikiWords += jeliza::string(s).get_lower();
            allWikiWords += "+";
            wikipedia_words.push_back(jeliza::string(s));
        }
    }
**/
}
void Dialog1::on_arin_save_clicked() {
/**
 ** Noch ueber Socket implementieren!!!!!!!!
 **
 **

    ofstream o("wikipedia_words.tmp");
    for (unsigned int x = 0; x < wikipedia_words.size(); x++) {
        o << wikipedia_words[x].ref() << " ";
    }
+*/
}

void Dialog1::on_proxy_ok_clicked() {
    jeliza::comm_send("PROXY:" + dia_options->ui_dia->proxy->displayText().toStdString()
                               + ":" + dia_options->ui_dia->proxy_port->displayText().toStdString() );
}

void Dialog2::on_save_clicked() {
    string all = ui_dia->editor->toPlainText().toStdString();
    ofstream o(file.c_str());
    o << all << endl;
    o.close();

    string x;
    stringstream sst;
    sst << all.size();
    sst >> x;

    jeliza::log(x + " bytes saved in " + file);

    hide();
}
void Dialog2::on_hide_clicked() {
    hide();
}
void JElizaWindow::on_actionInfo_triggered() {
    dia_help->show();
}
void Dialog3::on_changelog_clicked() {
    dia_changelog->show();
}

void Dialog4::init_changelog() {
    jeliza::string all;

    ifstream i("gpl.txt");
    jeliza::string temp;
    while (i) {
        getline(i, temp.ref());
        temp.strip();

        all += temp;
        all += "\n";
    }

    ui_dia->te_changelog->setText(QString(all.ref().c_str()));
}

void Dialog2::init_editor() {
    setWindowTitle(QApplication::translate("db_edit", full_name.c_str(), 0, QApplication::UnicodeUTF8));
    ui_dia->groupBox->setTitle(QApplication::translate("db_edit", full_name.c_str(), 0, QApplication::UnicodeUTF8));

}

void Dialog1::on_edit_modules_clicked() {
    dia_module_list_edit->file = "modules/index.cfg";
    dia_module_list_edit->full_name = "Editor fuer die Modulreihenfolge";
    dia_module_list_edit->init_editor();

    jeliza::string all;

    ifstream i("modules/index.cfg");
    jeliza::string temp;
    while (i) {
        getline(i, temp.ref());
        temp.strip();

        all += temp;
        all += "\n";
    }

    dia_module_list_edit->ui_dia->editor->setText(QString(all.ref().c_str()));
    dia_module_list_edit->show();
}

void Dialog1::on_edit_partners_clicked() {
    dia_module_list_edit->file = "temp/online_semantic_net_urls.txt";
    dia_module_list_edit->full_name = "Editor fuer Online-Partner";
    dia_module_list_edit->init_editor();

    jeliza::string all;

    ifstream i("temp/online_semantic_net_urls.txt");
    jeliza::string temp;
    while (i) {
        getline(i, temp.ref());
        temp.strip();

        all += temp;
        all += "\n";
    }

    dia_module_list_edit->ui_dia->editor->setText(QString(all.ref().c_str()));
    dia_module_list_edit->show();
}

QSize SemanticWidget::minimumSizeHint() const {
    return QSize(10000, 10000);
}
QSize SemanticWidget::sizeHint() const {
    return QSize(10000, 10000);
}

SemanticWidget::SemanticWidget(QDialog *Dialog)
: QWidget(Dialog), bg(10000, 10000), schon_gezeichnet(false)
{
    gridLayout = new QGridLayout(Dialog);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    gridLayout->setHorizontalSpacing(0);
    gridLayout->setVerticalSpacing(0);
    gridLayout->setContentsMargins(0, 0, 0, 0);

    QScrollArea* scrollArea = new QScrollArea;
    scrollArea->setBackgroundRole(QPalette::Dark);
    scrollArea->setWidget(this);

    gridLayout->addWidget(scrollArea, 2, 0, 1, 1);
    dia = Dialog;
}

void SemanticWidget::draw() {
    if (schon_gezeichnet) {
        return;
    }

    QPainter painter(&bg);

    painter.setPen(Qt::blue);
    painter.setFont(QFont("Sans Serif", 10));

    int x;
    int y;

    int nouns = 0;
    int advs = 0;
    int verbs = 0;
    int a = 0;
    int x2;
    int y2;
    int b = 0;

    int z;
    z = 0;

    painter.setPen(Qt::blue);
    ifstream i_li("temp/lines.tmp");
    z = 0;
    while (i_li) {
        if (x % 50 == 0) {
            i_li >> x >> y >> x2 >> y2;

            painter.drawLine(x, y, x2, y2);
        }
        ++x;
    }



    painter.setPen(Qt::white);
    ifstream i_co("temp/coord_words.tmp");
    string word;
    while (i_co) {
        i_co >> x >> y >> word;

        painter.drawText(x, y, QString::fromStdString(word));
    }
    painter.setPen(Qt::blue);



    painter.scale(0.2, 0.2);

    schon_gezeichnet = true;
}

void SemanticWidget::paintEvent(QPaintEvent *event) {
    draw();

    QPainter painter(this);
    painter.drawPixmap(0, 0, bg);
}

void JElizaWindow::on_w_verb_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:1");
    cout << "HERE_IS_WORD_TYPE:1" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_nomen_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:2");
    cout << "HERE_IS_WORD_TYPE:2" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_interj_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:7");
    cout << "HERE_IS_WORD_TYPE:7" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_interj2_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:7");
    cout << "HERE_IS_WORD_TYPE:7" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_name_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:2");
    cout << "HERE_IS_WORD_TYPE:2" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_adj_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:3");
    cout << "HERE_IS_WORD_TYPE:3" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_adv_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:3");
    cout << "HERE_IS_WORD_TYPE:3" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_pronomen_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:4");
    cout << "HERE_IS_WORD_TYPE:4" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_quesword_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:5");
    cout << "HERE_IS_WORD_TYPE:5" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_prep_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:6");
    cout << "HERE_IS_WORD_TYPE:6" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_adv_best_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:3");
    cout << "HERE_IS_WORD_TYPE:3" << endl;
    form->ui_form->msg_box->hide();
}
void JElizaWindow::on_w_break_clicked() {
    jeliza::comm_send("HERE_IS_WORD_TYPE:0");
    cout << "HERE_IS_WORD_TYPE:0" << endl;
    form->ui_form->msg_box->hide();
}

void JElizaWindow::on_male_clicked() {
    jeliza::comm_send("HERE_IS_GENUS:1");
    cout << "HERE_IS_GENUS:1" << endl;
    form->ui_form->msg_box_2->hide();
}

void JElizaWindow::on_female_clicked() {
    jeliza::comm_send("HERE_IS_GENUS:2");
    cout << "HERE_IS_GENUS:2" << endl;
    form->ui_form->msg_box_2->hide();
}

void JElizaWindow::on_thing_clicked() {
    jeliza::comm_send("HERE_IS_GENUS:3");
    cout << "HERE_IS_GENUS:3" << endl;
    form->ui_form->msg_box_2->hide();
}

void JElizaWindow::on_is_noun_clicked() {
    jeliza::comm_send("HERE_IS_NOUN_OR_NOT:1");
    cout << "HERE_IS_NOUN_OR_NOT:1" << endl;
    form->ui_form->msg_box_3->hide();
}

void JElizaWindow::on_not_is_noun_clicked() {
    jeliza::comm_send("HERE_IS_NOUN_OR_NOT:2");
    cout << "HERE_IS_NOUN_OR_NOT:2" << endl;
    form->ui_form->msg_box_3->hide();
}

void AnswerHelper::showMsgWindow() {
    form->ui_form->msg_box->show();
}
void AnswerHelper::hideMsgWindow() {
    form->ui_form->msg_box->hide();
}

void AnswerHelper::showMsgGenusWindow() {
    form->ui_form->msg_box_2->show();
}
void AnswerHelper::hideMsgGenusWindow() {
    form->ui_form->msg_box_2->hide();
}

void AnswerHelper::showMsgNounOrNotWindow() {
    form->ui_form->msg_box_3->show();
}
void AnswerHelper::hideMsgNounOrNotWindow() {
    form->ui_form->msg_box_3->hide();
}

void AnswerHelper::slotEverythingReady() {
    form->ui_form->lineEdit->setEnabled(true);
    form->ui_form->textEdit->setEnabled(true);
    form->ui_form->pushButton->setEnabled(true);
    form->ui_form->textEdit->setHtml(QString());
}

void jeliza::comm_new(jeliza::string s) {
    if (s.contains("ĹOG")) {
        cout << s.ref() << endl;
    }
    s = s.replace(":::", "::");
    s = s.replace("::", "----");
    s = s.replace(";", ",");
    s = s.replace(":", ";");

    jeliza::strings parts;
    util::split(s, ";", parts);

    for (unsigned int x = 0; x < parts.size(); x++) {
        parts[x] = parts[x].replace("----", ":");
    }


    if (parts.size() >= 2) {
        if (s.contains("DISPLAY")) {
            jeliza::display_sentence(parts[1]);
        }
        if (s.contains("SPEAK")) {
            speak(parts[1].ref());
        }
        if (s.contains("PERCENT")) {
            QString send;

            int fl;
            std::stringstream sst;
            sst << parts[1].ref();
            sst >> fl;

            if (fl == 0) {
                send = QString("JEliza hoert zu...");
            } else {
                send = QString("JEliza denkt nach...");
                // (" + QString(i.c_str()) + "%)
            }

            emit answerHelper->signalUpdateStatusbar(send);
            emit answerHelper->signalUpdateProgressbar((int)(fl));
            if (fl < 1) {
                emit answerHelper->signalHideProgressbar();
            }
            else {
                emit answerHelper->signalShowProgressbar();
            }

            emit answerHelper->signalUpdateStatusbar(send);

        }
        if (s.contains("LOG")) {
            QString s(parts[1].ref().c_str());
            s = s.replace("\n", "<br/>").replace(" ", "&nbsp;");

            (*jelizathread1_logs) += s + QString("<br/>");

            if ((*jelizathread1_logs).size() > 10000) {
                (*jelizathread1_logs) = "";
            }

//            form->ui_form->textEdit_2->setHtml(*jelizathread1_logs);
            emit answerHelper->signalLog(*jelizathread1_logs + QString("<a name=\"line\">&nbsp;</a>"));
            emit answerHelper->signalLogScrollEnd(QString("line"));
///            log(parts[1].ref());
        }
        if (s.contains("HERE_IS_DB_STRING")) {
            exportiere_db(parts[2].replace("<BR>", "\n").ref(), parts[1].replace("<BR>", "\n").ref());
        }
        if (s.contains("HERE_IS_ONLINE_DB_STRING")) {
            emit dia_options->signal_on_download_finished();
        }
        if (s.contains("IMPORT_DB_SUCCESS")) {
            emit dia_options->signal_on_import_finished();
        }
        if (s.contains("GET_WORD_TYPE")) {
/// <br>0. Abbruch. Keine Antwort.<br>1. Verb (z.B. sagen)<br>2. Name und Nomen (z.B Haus)<br>3. Adjektiv, Adverb oder adverbiale Bestimmung (z.B. schnell; immer, ueberall, gestern)<br>4. Pronomen (z.B er, sie, es)<br>5. Fragewort (z.B. warum, wie) oder Konjunktion<br>6. Praeposition (z.B. auf, an, unter)<br><br>Gib bitte die Nummer ein.

            emit answerHelper->signalMsg(QString(("Welche Wortart hat \"" + parts[1].ref() + "\"?").c_str()));
            emit answerHelper->signalShowMsgWindow();
        }
        if (s.contains("GET_GENUS")) {
            emit answerHelper->signalMsgGenus(QString(("Welches grammatische Geschlecht (Genus) hat das Wort \"" + parts[1].ref() + "\"? Nennt man es \"der " + parts[1].ref() + "\", \"die " + parts[1].ref() + "\" oder \"das " + parts[1].ref() + "\"??\nEventuell muessen Sie sich eine Endung, z.B: \"es\", wegdenken.").c_str()));
            emit answerHelper->signalShowMsgGenusWindow();
        }
        if (s.contains("GET_NOUN_OR_NOT")) {
            emit answerHelper->signalMsgNounOrNot(QString(("Dieses erste Wort in diesem Satz \"" + parts[1].ref() + "\" wurde gross geschrieben. Ist es als Nomen gemeint oder hat es in Wirklichkeit eine andere Wortart?").c_str()));
            emit answerHelper->signalShowMsgNounOrNotWindow();
        }
        if (s.contains("NAME")) {
            ki_name.set(parts[1]);
            emit answerHelper->signalChangeWindowTitle(QApplication::translate("jelizaWindow", ki_name.ref().c_str(), 0, QApplication::UnicodeUTF8));
            emit answerHelper->signalChangeHelpWindowText1(dia_help->ui_dia->label->text().replace("ABC", ki_name.ref().c_str()));
            emit answerHelper->signalChangeHelpWindowText2(dia_help->ui_dia->label_2->text().replace("ABC", ki_name.ref().c_str()));
        }
        if (s.contains("JELIZA_FULL_VERSION")) {
            version.set(parts[1]);
        }
        if (s.contains("READY")) {
            emit answerHelper->everythingReady();
        }
    }
}

/*namespace jeliza {
        void update_procent(float) { }
}*/


